\ProvidesPackage{lstaadlfiacre}
\RequirePackage{color}
\RequirePackage{macros}
\RequirePackage{listings}
\RequirePackage{parcolumns}
\RequirePackage{tabularx}

%lightgray
\definecolor{lightgray}{rgb}{.95, .95, .95}

% Style defintion
\lstdefinestyle{trad}{
	basicstyle=\ttfamily,
	backgroundcolor=\color{lightgray},
	tabsize=2,
%	aboveskip=-\medskipamount,
%	belowskip=-\medskipamount,
	keywordstyle=\bfseries\color{black},
	commentstyle=\color{gray},
	xleftmargin=1em,
	framexleftmargin=1em
}

\lstdefinestyle{query}{
	basicstyle=\footnotesize,
	aboveskip=-\medskipamount,
	belowskip=-\medskipamount,
	keywordstyle=\color{blue},
	commentstyle=\color{gray},
	tabsize=3
}

\lstdefinestyle{queryinline}{
	basicstyle=\small,
	keywordstyle=\color{blue},
	commentstyle=\color{gray},
	tabsize=2,
	showstringspaces=false
}

% AADL language definition
\lstdefinelanguage{aadl}[2005]{Ada}%
	{morekeywords={
		aadlboolean, aadlinteger, aadlreal, aadlstring, abstract, access, all,
		and, annex, applies, binding, bus, calls, classifier, connections,
		constant, data, delta, device, end, enumeration, event, extends, false,
		feature, features, flow, flows, group, implementation, in, inherit,
		initial, inverse, is, list, memory, mode, modes, none, not, of, or, out,
		package, parameter, path, port, private, process, processor, properties,
		property, prototypes, provides, public, range, record, reference,
		refined, refines, renames, requires, set, sink, source, subcomponents,
		subprogram, system, thread, to, true, type, units, virtual, with,
		behavior_specification, states, transitions, on, timeout, state, 
		complete, variables, initially
	}}
	
% Fiacre language definition
\lstdefinelanguage{fiacre}%
	{keywords={
		and, any, append, array, bool, case, channel, component, const, dequeue,
		do, else, elsif, empty, end, enqueue, false, first, foreach, from, full,
		if, in, int, init, is, loop, nat, none, null, of, on, or, out, par,
		port,
		priority, process, queue, read, record, self, states, then, to, true,
		type, union, unless, var, wait, where, while, write, default, select
	}, sensitive=true,comment=[s]{/*}{*/}}

% Acceleo query
\lstdefinelanguage{query}[OMG]{Ocl}%
{
	morekeywords={query, end, exists, iterate, flatten, collect, notEmpty, isEmpty, 
	              asSet, oclIsKindOf, union}
}

\newcommand{\nospace}{\abovedisplayshortskip=0pt \belowdisplayshortskip=0pt \abovedisplayskip=0pt \belowdisplayskip=0pt}

\newcommand{\newtrad}[1]{
	\LTXtable{\textwidth}{#1.tbl}
}

\newcommand{\trad}[2]{%
    \renewcommand{\tablename}{\textsc{Listing}}
	\begin{table}[htb]
		\begin{tabularx}{\textwidth}{X|X}
			\lstinputlisting[style=trad,language=aadl]
			{schema_transformation/#1.aadl}
			&
			\lstinputlisting[style=trad,language=fiacre, mathescape]
			{schema_transformation/#1.rtfcr}
		\end{tabularx}
		\caption{#2}
		\label{lst:#1}
	\end{table}
}

\lstnewenvironment{rtfcr}[1][]{\lstset{style=trad, language=fiacre,mathescape,#1}}{}
\lstnewenvironment{fcr}[1][]{\lstset{style=trad, language=fiacre,escapeinside='',texcl,#1}\footnotesize\vskip-.5\medskipamount}{\vskip-.5\medskipamount}
\lstnewenvironment{aadl}[1][]{\lstset{style=trad, language=aadl,escapeinside='',texcl,#1}\footnotesize\vskip-.5\medskipamount}{\vskip-.5\medskipamount}

\newenvironment{tradd}
{
\begin{parcolumns}[nofirstindent]{2}
	\vskip-\medskipamount
	\footnotesize
}
{
\end{parcolumns}
}

\newcommand{\traduction}[1]{
\begin{parcolumns}[nofirstindent, sloppy, sloppyspaces]{2}
	\vskip-\medskipamount
	\footnotesize
	\colchunk{
	  \lstinputlisting[style=trad,language=aadl, mathescape]{schema_transformation/#1.aadl}
	}
	\colchunk{
	  \lstinputlisting[style=trad,language=fiacre, escapeinside='', texcl, mathescape]
	     {schema_transformation/#1.rtfcr}
	}
\end{parcolumns}
}

\newcommand{\incltraduction}[1]{
\vskip-1em
\begin{parcolumns}[nofirstindent, distance=3.4em, sloppy, sloppyspaces]{2}
	\vskip-\medskipamount
	\footnotesize
	\colchunk{
	  \lstinputlisting[style=trad,language=aadl, escapeinside='', texcl, mathescape]{schema_transformation/#1.aadl}
	}
	\colchunk{
	  \lstinputlisting[style=trad,language=fiacre, escapeinside='', texcl, mathescape]
	     {schema_transformation/#1.rtfcr}
	}
\end{parcolumns}
}

\newcommand{\incltrad}[1]{%
		\begin{tabularx}{\textwidth}{X|X}
			\lstinputlisting[style=trad,language=aadl, mathescape]
			{schema_transformation/#1.aadl}
			&
			\lstinputlisting[style=trad,language=fiacre, mathescape]
			{schema_transformation/#1.rtfcr}
		\end{tabularx}
}

\newcommand{\acceleo}[1]{
	\lstinputlisting[style=query,language=query]{#1.ocl}
}